<?php
// $Id: logotool.import.inc,v 1.1.2.2 2010/02/13 22:55:12 pobster Exp $

/**
 * @file
 * Logotool import from directory functionality.
 */

/**
 * Form to collect system path to import directory.
 */
function logotool_import_form() {
  $form['path'] = array(
    '#type' => 'textfield',
    '#title' => t('Directory path'),
    '#description' => t('The path (relative to this Drupal installation) to the folder you wish to import from.'),
  );
  $form['commit'] = array(
    '#type' => 'submit',
    '#value' => t('Action!'),
  );
  return $form;
} // logotool_import_form

/**
 * Validation callback for import form.
 */
function logotool_import_form_validate(&$form, &$form_state) {
  if (!file_check_directory($form_state['values']['path'])) {
    form_set_error('path', t("Path '@path' does not exist.", array('@path' => $form_state['values']['path'])));
  }
} // logotool_import_form_validate

/**
 * Submit callback for import form.
 */
function logotool_import_form_submit($form, &$form_state) {
  if ($logos = $form_state['values']['path']) {
    global $user;
    $files = file_scan_directory($logos, '.*');
    foreach ((array)$files as $path => $file) {
      $file->filename = $file->basename;
      $file->filepath = $path;
      $file->filemime =  file_get_mimetype($path);
      $file->filesize = filesize($path);
      $file->uid = $user->uid;
      $file->status = FILE_STATUS_PERMANENT;
      $file->timestamp = time();
      // Save file to files table or report that it already exists.
      if (db_result(db_query("SELECT l.fid FROM {logotool} l INNER JOIN {files} f ON f.fid = l.fid WHERE f.filename = '%s'", $file->filename))) {
        drupal_set_message(t("Logo file '@filename' already exists, skipping...", array('@filename' => $file->filename)), 'error');
      }
      else {
        drupal_write_record('files', $file);
        db_query("INSERT INTO {logotool} (fid) VALUES (%d)", $file->fid);
        drupal_set_message(t("Imported logo file '@filename'.", array('@filename' => $file->filename)));
      }
    }
  }
} // logotool_import_form_submit